#pragma once


// ArmarX
#include <ArmarXCore/core/Component.h>

// RobotAPI
#include <RobotAPI/libraries/aron/core/navigator/data/AllNavigators.h>
#include <RobotAPI/interface/armem/server/WritingMemoryInterface.h>
#include <RobotAPI/interface/armem/mns/MemoryNameSystemInterface.h>

#include <RobotAPI/libraries/armem/client/Writer.h>
#include <RobotAPI/libraries/armem/client/MemoryNameSystemComponentPlugin.h>


namespace armarx::armem::client::plugins
{

    class WriterComponentPlugin : public ComponentPlugin
    {

    public:

        WriterComponentPlugin(ManagedIceObject& parent, std::string pre);
        ~WriterComponentPlugin() override;

    private:

        plugins::MemoryNameSystemComponentPlugin* mnsPlugin = nullptr;

    };
}


namespace armarx::armem::client
{
    class WriterComponentPluginUser :
        virtual public ManagedIceObject,
        virtual public MemoryNameSystemComponentPluginUser
    {

    public:

        WriterComponentPluginUser();
        ~WriterComponentPluginUser() override;

        virtual armem::data::WaitForMemoryResult useMemoryServer(const std::string& memoryName) override;
        using MemoryNameSystemComponentPluginUser::useMemoryServer;


    protected:

        void setWritingMemoryServer(server::WritingMemoryInterfacePrx memory);

        Writer memoryWriter;


    private:

        plugins::WriterComponentPlugin* plugin = nullptr;

    };

}
