#pragma once

#include <filesystem>

#include <RobotAPI/libraries/aron/core/navigator/type/container/Object.h>


namespace armarx::armem::d_ltm
{

    /**
     * @brief An entity container with a specific (Aron) type.
     */
    class TypeIO
    {
    public:

        static aron::typenavigator::ObjectNavigatorPtr unwrapType(const aron::typenavigator::ObjectNavigatorPtr& type);
        static aron::typenavigator::ObjectNavigatorPtr wrapType(const aron::typenavigator::ObjectNavigatorPtr& type);

        static aron::typenavigator::ObjectNavigatorPtr readAronType(const std::filesystem::path& filepath);
        static void writeAronType(const aron::typenavigator::ObjectNavigatorPtr& type, const std::filesystem::path& filepath);


    private:

        static const constexpr char* TYPE_FILENAME = "type";
        static constexpr const char* TYPE_WRAPPER_DATA_FIELD            = "__ARON_DATA";
        static constexpr const char* TYPE_WRAPPER_TIME_STORED_FIELD     = "__WRITER_METADATA__TIME_STORED";
        static constexpr const char* TYPE_WRAPPER_TIME_CREATED_FIELD    = "__ENTITY_METADATA__TIME_CREATED";
        static constexpr const char* TYPE_WRAPPER_TIME_SENT_FIELD       = "__ENTITY_METADATA__TIME_SENT";
        static constexpr const char* TYPE_WRAPPER_TIME_ARRIVED_FIELD    = "__ENTITY_METADATA__TIME_ARRIVED";
        static constexpr const char* TYPE_WRAPPER_CONFIDENCE_FIELD      = "__ENTITY_METADATA__CONFIDENCE";

    };

}
