#pragma once

#include "../base/CoreSegmentBase.h"

#include "ProviderSegment.h"

#include "../workingmemory/CoreSegment.h"


namespace armarx::armem::ltm
{

    /**
     * @brief Data of a core segment containing multiple provider segments.
     */
    class CoreSegment :
        public base::CoreSegmentBase<ProviderSegment, CoreSegment>
    {
        using Base = base::CoreSegmentBase<ProviderSegment, CoreSegment>;

    public:

        using Base::CoreSegmentBase;
        using Base::operator=;


        // Conversion
        wm::CoreSegment convert() const;

        // MongoDB connection
        void reload();
        void append(const wm::CoreSegment&);

    protected:
        virtual void _copySelf(CoreSegment& other) const override
        {
            Base::_copySelf(other);
            other.dbsettings = dbsettings;
        }

        virtual void _copySelfEmpty(CoreSegment& other) const override
        {
            Base::_copySelfEmpty(other);
            other.dbsettings = dbsettings;
        }

    public:
        MongoDBConnectionManager::MongoDBSettings dbsettings;
    };

}
