#include "MongoDBConnectionManager.h"

namespace armarx::armem::ltm
{
    bool MongoDBConnectionManager::initialized = false;
    std::map<std::string, mongocxx::client> MongoDBConnectionManager::Connections = {};

    mongocxx::client& MongoDBConnectionManager::EstablishConnection(const MongoDBSettings& settings)
    {
        if (!initialized)
        {
            initialized = true;
            mongocxx::instance instance{}; // This should be done only once.
        }

        const auto uri_str = settings.uri();
        const auto& it = Connections.find(uri_str);
        if (it == Connections.end())
        {
            mongocxx::uri uri(uri_str);
            auto con = Connections.emplace(uri_str, mongocxx::client(uri));
            return con.first->second;
        }
        else
        {
            // A connection already exists. We do not need to open another one.
            return it->second;
        }
    }
}
