#include "EntitySnapshot.h"

#include <ArmarXCore/core/exceptions/local/ExpressionException.h>

#include "error.h"


namespace armarx::armem::wm
{
    std::vector<aron::datanavigator::DictNavigatorPtr> EntitySnapshot::getAronData() const
    {
        std::vector<aron::datanavigator::DictNavigatorPtr> ret;
        for (const auto& aron : _container)
        {
            ret.push_back(aron.data());
        }
        return ret;
    }

    void EntitySnapshot::_copySelfWithoutData(EntitySnapshot& other) const
    {
        other.id() = _id;
        for (const auto& s : _container)
        {
            other.addInstance(s.copyWithoutData());
        }
    }
}
