#include "ProviderSegment.h"

#include <ArmarXCore/core/exceptions/local/ExpressionException.h>

#include "error.h"


namespace armarx::armem::wm
{

    Commit ProviderSegment::toCommit() const
    {
        Commit c;
        for (const auto& [k, s] : _container)
        {
            c.append(s.toCommit());
        }
        return c;
    }

    void ProviderSegment::_copySelfWithoutData(ProviderSegment& other) const
    {
        other.id() = _id;
        other.setMaxHistorySize(_maxHistorySize);
        for (const auto& [k, s] : _container)
        {
            other.addEntity(s.copyWithoutData());
        }
    }

}
