#include "DataDisplayVisitor.h"


namespace armarx::aron
{

    std::string DataDisplayVisitor::getValue(DataNavigator& n)
    {
        DataDisplayVisitor v;
        v.applyTo(n);
        return v.value.str();
    }

    bool DataDisplayVisitor::visitEnter(DictDataNavigator& n)
    {
        value << n.childrenSize() << " items";
        return false;
    }

    bool DataDisplayVisitor::visitEnter(ListDataNavigator& n)
    {
        value << n.childrenSize() << " items";
        return false;
    }

    bool DataDisplayVisitor::visit(BoolDataNavigator& b)
    {
        if (b.getValue())
        {
            value << "true";
        }
        else
        {
            value << "false";
        }
        return false;
    }

    bool DataDisplayVisitor::visit(DoubleDataNavigator& n)
    {
        value << n.getValue();
        return false;
    }

    bool DataDisplayVisitor::visit(FloatDataNavigator& n)
    {
        value << n.getValue();
        return false;
    }

    bool DataDisplayVisitor::visit(IntDataNavigator& n)
    {
        value << n.getValue();
        return false;
    }

    bool DataDisplayVisitor::visit(LongDataNavigator& n)
    {
        value << n.getValue();
        return false;
    }

    bool DataDisplayVisitor::visit(StringDataNavigator& n)
    {
        value << "'" << n.getValue() << "'";
        return false;
    }

    bool DataDisplayVisitor::visit(NDArrayDataNavigator& n)
    {
        value << "shape " << aron::datanavigator::NDArrayNavigator::DimensionsToString(n.getDimensions());
        return false;
    }


}
