#include "QueryWidget.h"

#include <QCheckBox>
#include <QHBoxLayout>
#include <QVBoxLayout>

#include <ArmarXCore/core/exceptions/local/ExpressionException.h>


namespace armarx::armem::gui
{

    QueryWidget::QueryWidget()
    {
        QVBoxLayout* layout = new QVBoxLayout();
        setLayout(layout);

        _dataCheckBox = new QCheckBox("Get Data");
        _dataCheckBox->setChecked(true);

        _tabWidget = new QTabWidget();

        _snapshotSelectorWidget = new SnapshotSelectorWidget();
        _tabWidget->addTab(_snapshotSelectorWidget, QString("Snapshots"));

        layout->addWidget(_dataCheckBox);
        layout->addWidget(_tabWidget);

        const int margin = 0;
        layout->setContentsMargins(margin, margin, margin, margin);


        // connect to queryChanged
    }


    armem::DataMode QueryWidget::dataMode() const
    {
        return _dataCheckBox->isChecked()
               ? armem::DataMode::WithData
               : armem::DataMode::NoData;
    }

    armem::client::QueryInput QueryWidget::queryInput()
    {
        armem::client::query::Builder qb(dataMode());
        qb
        .queryTarget(_snapshotSelectorWidget->queryTarget())
        .coreSegments().all()
        .providerSegments().all()
        .entities().all()
        .snapshots(_snapshotSelectorWidget->selector());

        return qb.buildQueryInput();
    }

}
